MAKEALL 23 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840
  1. #!/bin/bash
  2. # Tool mainly for U-Boot Quality Assurance: build one or more board
  3. # configurations with minimal verbosity, showing only warnings and
  4. # errors.
  5. #
  6. # SPDX-License-Identifier: GPL-2.0+
  7. usage()
  8. {
  9. # if exiting with 0, write to stdout, else write to stderr
  10. local ret=${1:-0}
  11. [ "${ret}" -eq 1 ] && exec 1>&2
  12. cat <<-EOF
  13. Usage: MAKEALL [options] [--] [boards-to-build]
  14. Options:
  15. -a ARCH, --arch ARCH Build all boards with arch ARCH
  16. -c CPU, --cpu CPU Build all boards with cpu CPU
  17. -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
  18. -s SOC, --soc SOC Build all boards with soc SOC
  19. -b BOARD, --board BOARD Build all boards with board name BOARD
  20. -l, --list List all targets to be built
  21. -m, --maintainers List all targets and maintainer email
  22. -M, --mails List all targets and all affilated emails
  23. -C, --check Enable build checking
  24. -n, --continue Continue (skip boards already built)
  25. -r, --rebuild-errors Rebuild any boards that errored
  26. -h, --help This help output
  27. Selections by these options are logically ANDed; if the same option
  28. is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
  29. will select all configurations where the vendor is either FOO or
  30. BAR. Any additional arguments specified on the command line are
  31. always build additionally. See the boards.cfg file for more info.
  32. If no boards are specified, then the default is "powerpc".
  33. Environment variables:
  34. BUILD_NCPUS number of parallel make jobs (default: auto)
  35. CROSS_COMPILE cross-compiler toolchain prefix (default: "")
  36. CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
  37. architecture "ARCH". Substitute "ARCH" for any
  38. supported architecture (default: "")
  39. MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
  40. BUILD_DIR output build directory (default: ./)
  41. BUILD_NBUILDS number of parallel targets (default: 1)
  42. Examples:
  43. - build all Power Architecture boards:
  44. MAKEALL -a powerpc
  45. MAKEALL --arch powerpc
  46. MAKEALL powerpc
  47. - build all PowerPC boards manufactured by vendor "esd":
  48. MAKEALL -a powerpc -v esd
  49. - build all PowerPC boards manufactured either by "keymile" or "siemens":
  50. MAKEALL -a powerpc -v keymile -v siemens
  51. - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
  52. MAKEALL -c mpc83xx -v freescale 4xx
  53. EOF
  54. exit ${ret}
  55. }
  56. SHORT_OPTS="ha:c:v:s:b:lmMCnr"
  57. LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
  58. # Option processing based on util-linux-2.13/getopt-parse.bash
  59. # Note that we use `"$@"' to let each command-line parameter expand to a
  60. # separate word. The quotes around `$@' are essential!
  61. # We need TEMP as the `eval set --' would nuke the return value of
  62. # getopt.
  63. TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
  64. -n 'MAKEALL' -- "$@"`
  65. [ $? != 0 ] && usage 1
  66. # Note the quotes around `$TEMP': they are essential!
  67. eval set -- "$TEMP"
  68. SELECTED=''
  69. ONLY_LIST=''
  70. PRINT_MAINTS=''
  71. MAINTAINERS_ONLY=''
  72. CONTINUE=''
  73. REBUILD_ERRORS=''
  74. while true ; do
  75. case "$1" in
  76. -a|--arch)
  77. # echo "Option ARCH: argument \`$2'"
  78. if [ "$opt_a" ] ; then
  79. opt_a="${opt_a%)} || \$2 == \"$2\")"
  80. else
  81. opt_a="(\$2 == \"$2\")"
  82. fi
  83. SELECTED='y'
  84. shift 2 ;;
  85. -c|--cpu)
  86. # echo "Option CPU: argument \`$2'"
  87. if [ "$opt_c" ] ; then
  88. opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
  89. else
  90. opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
  91. fi
  92. SELECTED='y'
  93. shift 2 ;;
  94. -s|--soc)
  95. # echo "Option SoC: argument \`$2'"
  96. if [ "$opt_s" ] ; then
  97. opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
  98. else
  99. opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
  100. fi
  101. SELECTED='y'
  102. shift 2 ;;
  103. -v|--vendor)
  104. # echo "Option VENDOR: argument \`$2'"
  105. if [ "$opt_v" ] ; then
  106. opt_v="${opt_v%)} || \$5 == \"$2\")"
  107. else
  108. opt_v="(\$5 == \"$2\")"
  109. fi
  110. SELECTED='y'
  111. shift 2 ;;
  112. -b|--board)
  113. # echo "Option BOARD: argument \`$2'"
  114. if [ "$opt_b" ] ; then
  115. opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
  116. else
  117. # We need to check the 7th field too
  118. # for boards whose 6th field is "-"
  119. opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
  120. fi
  121. SELECTED='y'
  122. shift 2 ;;
  123. -C|--check)
  124. CHECK='C=1'
  125. shift ;;
  126. -n|--continue)
  127. CONTINUE='y'
  128. shift ;;
  129. -r|--rebuild-errors)
  130. REBUILD_ERRORS='y'
  131. shift ;;
  132. -l|--list)
  133. ONLY_LIST='y'
  134. shift ;;
  135. -m|--maintainers)
  136. ONLY_LIST='y'
  137. PRINT_MAINTS='y'
  138. MAINTAINERS_ONLY='y'
  139. shift ;;
  140. -M|--mails)
  141. ONLY_LIST='y'
  142. PRINT_MAINTS='y'
  143. shift ;;
  144. -h|--help)
  145. usage ;;
  146. --)
  147. shift ; break ;;
  148. *)
  149. echo "Internal error!" >&2 ; exit 1 ;;
  150. esac
  151. done
  152. GNU_MAKE=$(scripts/show-gnu-make) || {
  153. echo "GNU Make not found" >&2
  154. exit 1
  155. }
  156. # echo "Remaining arguments:"
  157. # for arg do echo '--> '"\`$arg'" ; done
  158. tools/genboardscfg.py || {
  159. echo "Failed to generate boards.cfg" >&2
  160. exit 1
  161. }
  162. FILTER="\$1 !~ /^#/"
  163. [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
  164. [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
  165. [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
  166. [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
  167. [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
  168. if [ "$SELECTED" ] ; then
  169. SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
  170. # Make sure some boards from boards.cfg are actually found
  171. if [ -z "$SELECTED" ] ; then
  172. echo "Error: No boards selected, invalid arguments"
  173. exit 1
  174. fi
  175. fi
  176. #########################################################################
  177. # Print statistics when we exit
  178. trap exit 1 2 3 15
  179. trap print_stats 0
  180. # Determine number of CPU cores if no default was set
  181. : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
  182. if [ "$BUILD_NCPUS" -gt 1 ]
  183. then
  184. JOBS="-j $((BUILD_NCPUS + 1))"
  185. else
  186. JOBS=""
  187. fi
  188. if [ "${MAKEALL_LOGDIR}" ] ; then
  189. LOG_DIR=${MAKEALL_LOGDIR}
  190. else
  191. LOG_DIR="LOG"
  192. fi
  193. : ${BUILD_NBUILDS:=1}
  194. BUILD_MANY=0
  195. if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
  196. BUILD_MANY=1
  197. : ${BUILD_DIR:=./build}
  198. mkdir -p "${BUILD_DIR}/ERR"
  199. find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
  200. fi
  201. : ${BUILD_DIR:=.}
  202. OUTPUT_PREFIX="${BUILD_DIR}"
  203. [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
  204. if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
  205. find "${LOG_DIR}/" -type f -exec rm -f {} +
  206. fi
  207. LIST=""
  208. # Keep track of the number of builds and errors
  209. ERR_CNT=0
  210. ERR_LIST=""
  211. WRN_CNT=0
  212. WRN_LIST=""
  213. TOTAL_CNT=0
  214. SKIP_CNT=0
  215. CURRENT_CNT=0
  216. OLDEST_IDX=1
  217. RC=0
  218. # Helper funcs for parsing boards.cfg
  219. targets_by_field()
  220. {
  221. field=$1
  222. regexp=$2
  223. awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
  224. boards.cfg
  225. }
  226. targets_by_arch() { targets_by_field 2 "$@" ; }
  227. targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
  228. targets_by_soc() { targets_by_field 4 "$@" ; }
  229. #########################################################################
  230. ## MPC5xx Systems
  231. #########################################################################
  232. LIST_5xx="$(targets_by_cpu mpc5xx)"
  233. #########################################################################
  234. ## MPC5xxx Systems
  235. #########################################################################
  236. LIST_5xxx="$(targets_by_cpu mpc5xxx)"
  237. #########################################################################
  238. ## MPC512x Systems
  239. #########################################################################
  240. LIST_512x="$(targets_by_cpu mpc512x)"
  241. #########################################################################
  242. ## MPC8xx Systems
  243. #########################################################################
  244. LIST_8xx="$(targets_by_cpu mpc8xx)"
  245. #########################################################################
  246. ## PPC4xx Systems
  247. #########################################################################
  248. LIST_4xx="$(targets_by_cpu ppc4xx)"
  249. #########################################################################
  250. ## MPC8260 Systems (includes 8250, 8255 etc.)
  251. #########################################################################
  252. LIST_8260="$(targets_by_cpu mpc8260)"
  253. #########################################################################
  254. ## MPC83xx Systems (includes 8349, etc.)
  255. #########################################################################
  256. LIST_83xx="$(targets_by_cpu mpc83xx)"
  257. #########################################################################
  258. ## MPC85xx Systems (includes 8540, 8560 etc.)
  259. #########################################################################
  260. LIST_85xx="$(targets_by_cpu mpc85xx)"
  261. #########################################################################
  262. ## MPC86xx Systems
  263. #########################################################################
  264. LIST_86xx="$(targets_by_cpu mpc86xx)"
  265. #########################################################################
  266. ## PowerPC groups
  267. #########################################################################
  268. LIST_TSEC=" \
  269. ${LIST_83xx} \
  270. ${LIST_85xx} \
  271. ${LIST_86xx} \
  272. "
  273. LIST_powerpc=" \
  274. ${LIST_5xx} \
  275. ${LIST_512x} \
  276. ${LIST_5xxx} \
  277. ${LIST_8xx} \
  278. ${LIST_824x} \
  279. ${LIST_8260} \
  280. ${LIST_83xx} \
  281. ${LIST_85xx} \
  282. ${LIST_86xx} \
  283. ${LIST_4xx} \
  284. "
  285. # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
  286. # still using "ppc" instead of "powerpc"
  287. LIST_ppc=" \
  288. ${LIST_powerpc} \
  289. "
  290. #########################################################################
  291. ## StrongARM Systems
  292. #########################################################################
  293. LIST_SA="$(targets_by_cpu sa1100)"
  294. #########################################################################
  295. ## ARM7 Systems
  296. #########################################################################
  297. LIST_ARM7="$(targets_by_cpu arm720t)"
  298. #########################################################################
  299. ## ARM9 Systems
  300. #########################################################################
  301. LIST_ARM9="$(targets_by_cpu arm920t) \
  302. $(targets_by_cpu arm926ejs) \
  303. $(targets_by_cpu arm946es) \
  304. "
  305. #########################################################################
  306. ## ARM11 Systems
  307. #########################################################################
  308. LIST_ARM11="$(targets_by_cpu arm1136) \
  309. $(targets_by_cpu arm1176) \
  310. "
  311. #########################################################################
  312. ## ARMV7 Systems
  313. #########################################################################
  314. LIST_ARMV7="$(targets_by_cpu armv7)"
  315. #########################################################################
  316. ## ARMV8 Systems
  317. #########################################################################
  318. LIST_ARMV8="$(targets_by_cpu armv8)"
  319. #########################################################################
  320. ## AT91 Systems
  321. #########################################################################
  322. LIST_at91="$(targets_by_soc at91)"
  323. #########################################################################
  324. ## Xscale Systems
  325. #########################################################################
  326. LIST_pxa="$(targets_by_cpu pxa)"
  327. #########################################################################
  328. ## SPEAr Systems
  329. #########################################################################
  330. LIST_spear="$(targets_by_soc spear)"
  331. #########################################################################
  332. ## ARM groups
  333. #########################################################################
  334. LIST_arm="$(targets_by_arch arm | \
  335. for ARMV8_TARGET in $LIST_ARMV8; \
  336. do sed "/$ARMV8_TARGET/d"; \
  337. done) \
  338. "
  339. #########################################################################
  340. ## MIPS Systems (default = big endian)
  341. #########################################################################
  342. LIST_mips="$(targets_by_arch mips)"
  343. #########################################################################
  344. ## OpenRISC Systems
  345. #########################################################################
  346. LIST_openrisc="$(targets_by_arch openrisc)"
  347. #########################################################################
  348. ## x86 Systems
  349. #########################################################################
  350. LIST_x86="$(targets_by_arch x86)"
  351. #########################################################################
  352. ## Nios-II Systems
  353. #########################################################################
  354. LIST_nios2="$(targets_by_arch nios2)"
  355. #########################################################################
  356. ## MicroBlaze Systems
  357. #########################################################################
  358. LIST_microblaze="$(targets_by_arch microblaze)"
  359. #########################################################################
  360. ## ColdFire Systems
  361. #########################################################################
  362. LIST_m68k="$(targets_by_arch m68k)"
  363. LIST_coldfire=${LIST_m68k}
  364. #########################################################################
  365. ## AVR32 Systems
  366. #########################################################################
  367. LIST_avr32="$(targets_by_arch avr32)"
  368. #########################################################################
  369. ## Blackfin Systems
  370. #########################################################################
  371. LIST_blackfin="$(targets_by_arch blackfin)"
  372. #########################################################################
  373. ## SH Systems
  374. #########################################################################
  375. LIST_sh2="$(targets_by_cpu sh2)"
  376. LIST_sh3="$(targets_by_cpu sh3)"
  377. LIST_sh4="$(targets_by_cpu sh4)"
  378. LIST_sh="$(targets_by_arch sh)"
  379. #########################################################################
  380. ## SPARC Systems
  381. #########################################################################
  382. LIST_sparc="$(targets_by_arch sparc)"
  383. #########################################################################
  384. ## NDS32 Systems
  385. #########################################################################
  386. LIST_nds32="$(targets_by_arch nds32)"
  387. #########################################################################
  388. ## ARC Systems
  389. #########################################################################
  390. LIST_arc="$(targets_by_arch arc)"
  391. #-----------------------------------------------------------------------
  392. get_target_location() {
  393. local target=$1
  394. local BOARD_NAME=""
  395. local CONFIG_NAME=""
  396. local board=""
  397. local vendor=""
  398. # Automatic mode
  399. local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
  400. if [ -z "${line}" ] ; then echo "" ; return ; fi
  401. set ${line}
  402. CONFIG_NAME="${7%_defconfig}"
  403. [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
  404. if [ $# -gt 5 ]; then
  405. if [ "$6" = "-" ] ; then
  406. board=${BOARD_NAME}
  407. else
  408. board="$6"
  409. fi
  410. fi
  411. [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
  412. [ $# -gt 6 ] && [ "$8" != "-" ] && {
  413. tmp="${8%:*}"
  414. if [ "$tmp" ] ; then
  415. CONFIG_NAME="$tmp"
  416. fi
  417. }
  418. # Assign board directory to BOARDIR variable
  419. if [ "${vendor}" == "-" ] ; then
  420. BOARDDIR=${board}
  421. else
  422. BOARDDIR=${vendor}/${board}
  423. fi
  424. echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
  425. }
  426. get_target_maintainers() {
  427. local name=`echo $1 | cut -d : -f 3`
  428. local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
  429. if [ -z "${line}" ]; then
  430. echo ""
  431. return ;
  432. fi
  433. local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
  434. [ "$mails" == "-" ] && mails=""
  435. echo "$mails"
  436. }
  437. get_target_arch() {
  438. local target=$1
  439. awk '$7 == "'$target'" { print $2 }' boards.cfg
  440. }
  441. list_target() {
  442. if [ "$PRINT_MAINTS" != 'y' ] ; then
  443. echo "$1"
  444. return
  445. fi
  446. echo -n "$1:"
  447. local loc=`get_target_location $1`
  448. if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
  449. local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
  450. if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
  451. local dir=`echo ${loc} | cut -d ":" -f 2`
  452. local cfg=`echo ${loc} | cut -d ":" -f 1`
  453. local git_result=`git log --format=%aE board/${dir} \
  454. include/configs/${cfg}.h | grep "@"`
  455. local git_result_recent=`echo ${git_result} | tr " " "\n" | \
  456. head -n 3`
  457. local git_result_top=`echo ${git_result} | tr " " "\n" | \
  458. sort | uniq -c | sort -nr | head -n 3 | \
  459. sed "s/^ \+[0-9]\+ \+//"`
  460. echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
  461. sort -u | tr "\n" " " | sed "s/ $//" ;
  462. else
  463. echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
  464. sed "s/ $//" ;
  465. fi
  466. echo ""
  467. }
  468. # Each finished build will have a file called ${donep}${n},
  469. # where n is the index of the build. Each build
  470. # we've already noted as finished will have ${skipp}${n}.
  471. # The code managing the build process will use this information
  472. # to ensure that only BUILD_NBUILDS builds are in flight at once
  473. donep="${LOG_DIR}/._done_"
  474. skipp="${LOG_DIR}/._skip_"
  475. build_target_killed() {
  476. echo "Aborted $target build."
  477. # Remove the logs for this board since it was aborted
  478. rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
  479. exit
  480. }
  481. build_target() {
  482. target=$1
  483. build_idx=$2
  484. if [ "$ONLY_LIST" == 'y' ] ; then
  485. list_target ${target}
  486. return
  487. fi
  488. if [ $BUILD_MANY == 1 ] ; then
  489. output_dir="${OUTPUT_PREFIX}/${target}"
  490. mkdir -p "${output_dir}"
  491. trap build_target_killed TERM
  492. else
  493. output_dir="${OUTPUT_PREFIX}"
  494. fi
  495. target_arch=$(get_target_arch ${target})
  496. eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
  497. if [ "${cross_toolchain}" ] ; then
  498. MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
  499. elif [ "${CROSS_COMPILE}" ] ; then
  500. MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
  501. else
  502. MAKE=$GNU_MAKE
  503. fi
  504. if [ "${output_dir}" != "." ] ; then
  505. MAKE="${MAKE} O=${output_dir}"
  506. fi
  507. ${MAKE} mrproper >/dev/null
  508. echo "Building ${target} board..."
  509. ${MAKE} -s ${target}_defconfig >/dev/null
  510. ${MAKE} ${JOBS} ${CHECK} all \
  511. >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
  512. # Check for 'make' errors
  513. if [ ${PIPESTATUS[0]} -ne 0 ] ; then
  514. RC=1
  515. fi
  516. OBJS=${output_dir}/u-boot
  517. if [ -e ${output_dir}/spl/u-boot-spl ]; then
  518. OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
  519. fi
  520. ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
  521. if [ $BUILD_MANY == 1 ] ; then
  522. trap - TERM
  523. ${MAKE} -s clean
  524. if [ -s ${LOG_DIR}/${target}.ERR ] ; then
  525. cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
  526. else
  527. rm ${LOG_DIR}/${target}.ERR
  528. fi
  529. else
  530. if [ -s ${LOG_DIR}/${target}.ERR ] ; then
  531. if grep -iw error ${LOG_DIR}/${target}.ERR ; then
  532. : $(( ERR_CNT += 1 ))
  533. ERR_LIST="${ERR_LIST} $target"
  534. else
  535. : $(( WRN_CNT += 1 ))
  536. WRN_LIST="${WRN_LIST} $target"
  537. fi
  538. else
  539. rm ${LOG_DIR}/${target}.ERR
  540. fi
  541. fi
  542. [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
  543. touch "${donep}${build_idx}"
  544. }
  545. manage_builds() {
  546. search_idx=${OLDEST_IDX}
  547. if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
  548. while true; do
  549. if [ -e "${donep}${search_idx}" ] ; then
  550. : $(( CURRENT_CNT-- ))
  551. [ ${OLDEST_IDX} -eq ${search_idx} ] &&
  552. : $(( OLDEST_IDX++ ))
  553. # Only want to count it once
  554. rm -f "${donep}${search_idx}"
  555. touch "${skipp}${search_idx}"
  556. elif [ -e "${skipp}${search_idx}" ] ; then
  557. [ ${OLDEST_IDX} -eq ${search_idx} ] &&
  558. : $(( OLDEST_IDX++ ))
  559. fi
  560. : $(( search_idx++ ))
  561. if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
  562. if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
  563. search_idx=${OLDEST_IDX}
  564. sleep 1
  565. else
  566. break
  567. fi
  568. fi
  569. done
  570. }
  571. build_targets() {
  572. for t in "$@" ; do
  573. # If a LIST_xxx var exists, use it. But avoid variable
  574. # expansion in the eval when a board name contains certain
  575. # characters that the shell interprets.
  576. case ${t} in
  577. *[-+=]*) list= ;;
  578. *) list=$(eval echo '${LIST_'$t'}') ;;
  579. esac
  580. if [ -n "${list}" ] ; then
  581. build_targets ${list}
  582. else
  583. : $((TOTAL_CNT += 1))
  584. : $((CURRENT_CNT += 1))
  585. rm -f "${donep}${TOTAL_CNT}"
  586. rm -f "${skipp}${TOTAL_CNT}"
  587. if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
  588. : $((SKIP_CNT += 1))
  589. touch "${donep}${TOTAL_CNT}"
  590. elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
  591. : $((SKIP_CNT += 1))
  592. touch "${donep}${TOTAL_CNT}"
  593. else
  594. if [ $BUILD_MANY == 1 ] ; then
  595. build_target ${t} ${TOTAL_CNT} &
  596. else
  597. CUR_TGT="${t}"
  598. build_target ${t} ${TOTAL_CNT}
  599. CUR_TGT=''
  600. fi
  601. fi
  602. fi
  603. # We maintain a running count of all the builds we have done.
  604. # Each finished build will have a file called ${donep}${n},
  605. # where n is the index of the build. Each build
  606. # we've already noted as finished will have ${skipp}${n}.
  607. # We track the current index via TOTAL_CNT, and the oldest
  608. # index. When we exceed the maximum number of parallel builds,
  609. # We look from oldest to current for builds that have completed,
  610. # and update the current count and oldest index as appropriate.
  611. # If we've gone through the entire list, wait a second, and
  612. # reprocess the entire list until we find a build that has
  613. # completed
  614. if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
  615. manage_builds
  616. fi
  617. done
  618. }
  619. #-----------------------------------------------------------------------
  620. kill_children() {
  621. local OS=$(uname -s)
  622. local children=""
  623. case "${OS}" in
  624. "Darwin")
  625. # Mac OS X is known to have BSD style ps
  626. local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
  627. children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
  628. ;;
  629. *)
  630. # everything else tries the GNU style
  631. local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
  632. children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
  633. ;;
  634. esac
  635. kill $children 2> /dev/null
  636. wait $children 2> /dev/null
  637. exit
  638. }
  639. print_stats() {
  640. if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
  641. # Only count boards that completed
  642. : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
  643. rm -f ${donep}* ${skipp}*
  644. if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
  645. ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
  646. ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
  647. ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
  648. WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
  649. WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
  650. WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
  651. else
  652. # Remove the logs for any board that was interrupted
  653. rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
  654. fi
  655. : $((TOTAL_CNT -= ${SKIP_CNT}))
  656. echo ""
  657. echo "--------------------- SUMMARY ----------------------------"
  658. if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
  659. echo "Boards skipped: ${SKIP_CNT}"
  660. fi
  661. echo "Boards compiled: ${TOTAL_CNT}"
  662. if [ ${ERR_CNT} -gt 0 ] ; then
  663. echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
  664. fi
  665. if [ ${WRN_CNT} -gt 0 ] ; then
  666. echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
  667. fi
  668. echo "----------------------------------------------------------"
  669. if [ $BUILD_MANY == 1 ] ; then
  670. kill_children
  671. fi
  672. exit $RC
  673. }
  674. #-----------------------------------------------------------------------
  675. # Build target groups selected by options, plus any command line args
  676. set -- ${SELECTED} "$@"
  677. # run PowerPC by default
  678. [ $# = 0 ] && set -- powerpc
  679. build_targets "$@"
  680. wait